unit hauptu;

interface
// pixelevolution vom 16.03.2009

uses
  Windows, Messages, SysUtils, Classes, Graphics,Controls,
  Forms,ExtCtrls, StdCtrls, XPMan, Spin,inifiles;

const
  _caption='Pixel-Evolution von Daniel Schwamm (Maerz 2009)';

  //parameter-datei
  _inifn='pixelevolution.ini';

  //maximale anzahl beute und jaeger
  //insgesamt kann es 2*_leben_max Viehzeug geben
  _leben_max=5000;

  //unbenutze array-position
  _leben_unbenutzt=-2;

  //momentan freie array-position
  _leben_frei=-1;

   //minimale lebensdauer (in jahren)
   //Variationsgrenze nach unten
  _jaeger_lebensdauer_min=10;

  //wenn diese prozent-zahl der dichte ueberschritten wird
  //greift lernregel zur verringerung der lebensdauer
  jaeger_lern_minus=70;

  //wenn diese prozent-zahl der dichte unterschritten wird
  //greift lernregel zur erhoehung der lebensdauer
  jaeger_lern_plus=30;

  //mininmal teildauer (in jahren)
  _beute_teildauer_min=3;

  //wenn diese prozent-zahl der dichte ueberschritten wird
  //greift lernregel zur erhoehung der teildauer
  beute_lern_plus=70;

  //wenn diese prozent-zahl der dichte unterschritten wird
  //greift lernregel zur verringerung der teildauer
  beute_lern_minus=30;

  //anzahl beute die jaeger schnappen muss zur duplizierung
  _beute_fuer_duplikat=4;


  //dichte-array-zeichen
  _dichte_frei=' ';
  _dichte_jaeger='j';
  _dichte_beute='b';

type
  //lebenseinheit: entweder jaeger oder beute
  TLeben=record
    x:smallint;         //x-koordinate der position
    y:smallint;         //y-koordinate der position
    zaehler:smallint;   //lebensdauer, wenn jaeger
                        //teildauer, wenn beute
    gefressen:smallint; //gefressene beute, wenn jaeger
  end;

  //-------------------------------------------------
  Thauptf = class(TForm)
    optionen_p: TPanel;
    startb: TButton;
    Label1: TLabel;
    Label2: TLabel;
    mitte_p: TPanel;
    pb: TPaintBox;
    XPManifest1: TXPManifest;
    jaeger_zaehler_e: TEdit;
    beute_zaehler_e: TEdit;
    Speed: TLabel;
    Label8: TLabel;
    Runden: TLabel;
    runden_zaehler_e: TEdit;
    groesse_se: TSpinEdit;
    jaeger_lebensdauer_se: TSpinEdit;
    beute_teildauer_se: TSpinEdit;
    bremse_se: TSpinEdit;
    pauseb: TButton;
    jaeger_start_se: TSpinEdit;
    beute_start_se: TSpinEdit;
    jaeger_max_se: TSpinEdit;
    beute_max_se: TSpinEdit;
    jaeger_lebensdauer_start_se: TSpinEdit;
    beute_teildauer_start_se: TSpinEdit;
    jaeger_lern_se: TSpinEdit;
    beute_lern_se: TSpinEdit;
    jaeger_variation_se: TSpinEdit;
    beute_variation_se: TSpinEdit;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure startbClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject;var CanClose: Bool);
    procedure pausebClick(Sender: TObject);
    procedure mitte_pResize(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }

    //heimat-verzeichnis
    homedir:string;

    //puffer-bitmap
    bmp:tbitmap;

    //jaeger- und beute-array
    Jaeger_ar:array[0.._leben_max]of TLeben;
    Beute_ar:array[0.._leben_max]of TLeben;

    //anzahl aktive jaeger, aktive beute
    jaeger_zaehler,beute_zaehler:smallint;

    //dichte-array
    dichte_ar:array[0.._leben_max,0.._leben_max]of char;

    //variablen fuer die grafik-ausgabe
    raster_rand_breite,raster_rand_hoehe:smallint;
    raster_breite_max,raster_hoehe_max:smallint;

    //allgemeine leben-funktionen
    procedure leben_neu(
      var ar:array of TLeben;
      jaeger_ok:boolean
    );
    function leben_finde(
      var ar:array of tleben;
      inx:smallint;var x,y:smallint;
      jaeger_ok:boolean
    ):boolean;
    function leben_bewegung(
      var ar:array of TLeben;
      inx,x_gefunden,y_gefunden:smallint;
      jaeger_ok:boolean
    ):smallint;
    function leben_duplikat(
      var ar:array of tleben;
      inx:smallint;
      jaeger_ok:boolean;
      var start_index:smallint
    ):boolean;
    function leben_zaehlen_malen(
      var ar:array of tleben;
      jaeger_ok:boolean
    ):smallint;
    function leben_vorhanden(
      var ar:array of TLeben;
      x,y:smallint;
      var inx:smallint;
      jaeger_ok:boolean
    ):boolean;
    function leben_dichte(
      var ar:array of TLeben;
      inx:smallint;
      jaeger_ok:boolean;
      var dichte_max:smallint
    ):smallint;

    //jaeger-funktionen
    function jaeger_variation:smallint;
    procedure jaeger_bewegen(
      var dichte,dichte_max:smallint;
      var duplikat_ok:boolean
    );
    procedure jaeger_lernen(
      dichte,dichte_max:smallint;
      duplikat_ok:boolean
    );
    function jaeger_vorhanden(
      x,y:smallint;
      var inx:smallint
    ):boolean;

    //leben-funktionen
    function beute_variation:smallint;
    procedure beute_bewegen(
      var dichte,dichte_max:smallint;
      var duplikat_ok:boolean
    );
    procedure beute_lernen(
      dichte,dichte_max:smallint;
      duplikat_ok:boolean
    );
    function beute_vorhanden(
      x,y:smallint;
      var inx:smallint
    ):boolean;

    //positionierung-funktionen
    function pos_raster_x(x:smallint):smallint;
    function pos_raster_y(y:smallint):smallint;
    function pos_delta:smallint;

    //evolution-funktionen
    procedure evolution;
    procedure evolution_init;
    procedure evolution_ausgabe;

    //sonstiges
    procedure pause(ms:smallint);
    procedure knoepfe_setzen(evolution_ok:boolean);
    procedure dichte_ar_setzen(
      x,y:smallint;
      jaeger_ok,
      clr_ok:boolean
    );
    function bremsen_pause_abbruch:boolean;
  end;

var
  hauptf: Thauptf;

implementation

{$R *.dfm}

//********************************************************
//FORM-FUNKTIONEN
//********************************************************

//-------------------------------------------------------
//programm-start
//-------------------------------------------------------
procedure Thauptf.FormCreate(Sender: TObject);
var
  r:smallint;
  se:tspinedit;
begin
  //echter zufall
  randomize;

  //umgebung setzen
  caption:=_caption;
  homedir:=extractfilepath(application.exename);
  mitte_p.ParentBackground:=false;
  mitte_p.color:=clblack;
  mitte_p.Align:=alclient;
  pb.Align:=alclient;
  optionen_p.ParentBackground:=false;
  optionen_p.color:=clsilver;

  //anzahl jaeger option: minima und maxima
  jaeger_start_se.MinValue:=1;
  jaeger_start_se.MaxValue:=_leben_max;
  jaeger_max_se.MinValue:=1;
  jaeger_max_se.MaxValue:=_leben_max;

  //anzahl beute option: minima und maxima
  beute_start_se.MinValue:=1;
  beute_start_se.Maxvalue:=_leben_max;
  beute_max_se.MinValue:=1;
  beute_max_se.Maxvalue:=_leben_max;

  //puffer-bitmap initialisieren
  bmp:=tbitmap.Create;
  bmp.PixelFormat:=pf24bit;
  bmp.canvas.Brush.style:=bssolid;
  bmp.canvas.pen.width:=1;
  bmp.Canvas.pen.color:=clblack;

  //parameter einladen: spinedits fuellen
  with tinifile.create(homedir+_inifn) do begin
    for r:=0 to componentcount-1 do begin
      if not(components[r] is tspinedit) then continue;
      se:=tspinedit(components[r]);
      se.value:=readinteger('param',se.name,se.value);
    end;
    free;
  end;

  knoepfe_setzen(false);
end;

//-------------------------------------------------------
//programm-ende
//-------------------------------------------------------
procedure Thauptf.FormDestroy(Sender: TObject);
var
  r:smallint;
  se:tspinedit;
begin
  //parameter sichern
  deletefile(homedir+_inifn);
  with tinifile.create(homedir+_inifn) do begin
    for r:=0 to componentcount-1 do begin
      if not(components[r] is tspinedit) then continue;
      se:=tspinedit(components[r]);
      writeinteger('param',se.name,se.value);
    end;
    free;
  end;
  bmp.free;
end;

//-------------------------------------------------------
//programm-ende moeglich?
//-------------------------------------------------------
procedure Thauptf.FormCloseQuery(Sender:TObject;var CanClose:bool);
begin
  //ist evolution fertig?
  canclose:=(startb.caption='Start');
end;

//-------------------------------------------------------
//pause-knopf gedrueckt
//-------------------------------------------------------
procedure Thauptf.pausebClick(Sender: TObject);
begin
  if pauseb.caption='Pause' then
    //pause aktivieren
    pauseb.caption:='Weiter'
  else
    //pause beenden
    pauseb.caption:='Pause';
end;

//-------------------------------------------------------
//tastatur-ereignis abfangen
//-------------------------------------------------------
procedure Thauptf.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key=vk_escape then close;
end;

//-------------------------------------------------------
//groessenaenderung-ereignis abfangen
//-------------------------------------------------------
procedure Thauptf.mitte_pResize(Sender: TObject);
begin
  //puffer-bitmap anpassen
  bmp.width:=pb.width;
  bmp.height:=pb.height;

  //block-parameter anpassen (z.B. fuer dichte-koordinaten)
  raster_rand_breite:=(pb.width mod groesse_se.value) div 2;
  raster_rand_hoehe:=(pb.height mod groesse_se.value) div 2;
  raster_breite_max:=(pb.width div groesse_se.value)-1;
  raster_hoehe_max:=(pb.height div groesse_se.value)-1;
end;

//-------------------------------------------------------
//start-knopf gedrueckt
//-------------------------------------------------------
procedure Thauptf.startbClick(Sender: TObject);
begin
  if startb.caption='STOPP' then begin
    //evolution stoppen
    startb.caption:='Start';
    exit;
  end;
  //evolution beginnen
  evolution;
end;


//********************************************************
//PROGRAMM-FUNKTIONEN
//********************************************************

//-------------------------------------------------------
//zufaelliger delta-wert, der zu x/y-koordinaten addiert
//oder subtrahiert wird, je nach Richtung
//-------------------------------------------------------
function thauptf.pos_delta:smallint;
begin
  //0 oder ein 'schritt'
  result:=random(2)*groesse_se.value;
end;

//--------------------------------------------------------
//fuelle jaeger-array oder beute-array mit zufaellig
//verteiltem leben
//--------------------------------------------------------
procedure thauptf.leben_neu(
  var ar:array of TLeben;
  jaeger_ok:boolean
);
var
  r,x,y,dum,max:smallint;
begin
  //zu generierende anzahl jaeger bzw. beute
  if jaeger_ok then max:=jaeger_start_se.value
               else max:=beute_start_se.value;

  dum:=_leben_frei;
  for r:=0 to max-1 do begin
    //suche freie position
    repeat
      //zufaellige koordinaten
      x:=pos_raster_x(random(pb.width));
      y:=pos_raster_y(random(pb.height));

      //pruefe, ob dort kein leben ist
    until not  beute_vorhanden(x,y,dum) and
          not jaeger_vorhanden(x,y,dum);

    //initiiere neuen jaeger bzw. neue beute
    if jaeger_ok then
      //lebensdauer mit variations-anteil
      ar[r].zaehler:=jaeger_variation
    else
      //teildauer mit variations-anteil
      ar[r].zaehler:=beute_variation;

    ar[r].x:=x;
    ar[r].y:=y;
    ar[r].gefressen:=0;
  end;
end;

//--------------------------------------------------------
//setze im dichte_array jaeger-, beute- oder frei-zeichen
//--------------------------------------------------------
procedure thauptf.dichte_ar_setzen(
  x,y:smallint;
  jaeger_ok:boolean;
  clr_ok:boolean
);
begin
  //leben-pixel-koordinaten umwandeln
  //in dichte-array-koordinaten
  x:=x div groesse_se.value;
  y:=y div groesse_se.value;

  //dort dichte-array fuellen
  if      clr_ok    then dichte_ar[x,y]:=_dichte_frei
  else if jaeger_ok then dichte_ar[x,y]:=_dichte_jaeger
                    else dichte_ar[x,y]:=_dichte_beute;
end;


//-------------------------------------------------------
//lass jaeger der naechsten generation etwas lernen
//-------------------------------------------------------
procedure thauptf.jaeger_lernen(
  dichte:smallint;      //aktuelle dichte
  dichte_max:smallint;  //maximal moegliche dichte
  duplikat_ok:boolean   //mindestens eine reproduktion?
);
var
  dichte_proz:double;
begin
  //wahrscheinlichkeit, dass lernschritt stattfindet
  if random(100)>=jaeger_lern_se.value then exit;

  //hat sich mindestens ein jaeger repliziert?
  if duplikat_ok then begin
    //verkuerze lebensdauer der naechsten generation
    jaeger_lebensdauer_se.value:=jaeger_lebensdauer_se.value-1;
  end;

  //'korrektur' der maximal moeglichen dichte
  //ein jaeger benoetigt x beute
  dichte_max:=dichte_max div _beute_fuer_duplikat;
  if dichte_max=0 then exit;

  //wieviel prozent dichte haben die jger von der
  //modifizierten maximal mglichen dichte erreicht?
  dichte_proz:=(dichte*100)/dichte_max;

  //jaeger haben viele direkte nachbarn?
  if dichte_proz>jaeger_lern_minus then begin
    //ueberbevoelkerung:
    //verkuerze lebensdauer der naechsten generation
    jaeger_lebensdauer_se.value:=jaeger_lebensdauer_se.value-1;
  end

  //jaeger haben wenige direkte nachbarn?
  else if dichte_proz<jaeger_lern_plus then begin
    //unterbevoelkerung:
    //erhoehe lebensdauer der naechsten generation
    jaeger_lebensdauer_se.value:=jaeger_lebensdauer_se.value+1;
  end;
end;

//-------------------------------------------------------
//lass beute der naechsten generation etwas lernen
//-------------------------------------------------------
procedure thauptf.beute_lernen(
  dichte:smallint;      //aktuelle dichte
  dichte_max:smallint;  //maximal moegliche dichte
  duplikat_ok:boolean   //mindestens eine reproduktion?
);
var
  dichte_proz:double;
begin
  //wahrscheinlichkeit, dass lernschritt stattfindet
  if random(100)>=beute_lern_se.value then exit;

  //hat sich mindestens eine beute repliziert?
  if duplikat_ok then begin
    //erhoehe teildauer der naechsten generation
    beute_teildauer_se.value:=beute_teildauer_se.value+1;
  end;

  //'korrektur' der maximal moeglichen dichte
  //beue benoetigt freien platz zu reprouktion/flucht
  dichte_max:=(dichte_max*3) div 4;
  if dichte_max=0 then exit;

  //wieviel prozent dichte hat die beute von der
  //modifizierten maximal mglichen dichte erreicht?
  dichte_proz:=(dichte*100)/dichte_max;

  //beute haben viele direkte nachbarn?
  if dichte_proz>beute_lern_plus then begin
    //ueberbevoelkerung:
    //erhoehe teildauer der naechsten generation
    beute_teildauer_se.value:=beute_teildauer_se.value+1;
  end

  //beute haben wenige direkte nachbarn?
  else if dichte_proz<beute_lern_minus then begin
    //unterbevoelkerung:
    //verringere teildauer der naechsten generation
    beute_teildauer_se.value:=beute_teildauer_se.value-1;
  end;
end;

//-------------------------------------------------------
//ein jaeger oder eine beute reproduziert sich
//liefert true zurueck, wenn alles klappt
//-------------------------------------------------------
function thauptf.leben_duplikat(
  var ar:array of tleben;  //jaeger- oder beute-array
  inx:smallint;            //index des jaegers/der beute
  jaeger_ok:boolean;       //jaeger?
  var start_index:smallint //start-index im array
):boolean;
var
  r,x,y,max,dum:smallint;
  found_ok:boolean;
begin
  result:=false;

  try
    if jaeger_ok then max:=jaeger_max_se.value
                 else max:=beute_max_se.value;

    //suche freie array-position
    found_ok:=false;
    for r:=start_index to max-1 do begin
      //jaeger/beute aktiv?
      if ar[r].zaehler>=0 then continue;

      //freien index sichern
      start_index:=r;
      found_ok:=true;
      break;
    end;
    if not found_ok then exit;

    //zufallsposition in nachbarschaft
    //des lebewesens, das sich repliziert
    x:=ar[inx].x+pos_delta-pos_delta;
    y:=ar[inx].y+pos_delta-pos_delta;

    //position modulieren
    x:=pos_raster_x(x);
    y:=pos_raster_y(y);

    //ort identisch mit original?
    if(ar[inx].x=x)and(ar[inx].y=y)then exit;

    //ort von anderem lebewesen besetzt?
    dum:=_leben_frei;
    if
      beute_vorhanden(x,y,dum) or
      jaeger_vorhanden(x,y,dum)
    then exit;

    //okay, duplizierung vornehmen
    if jaeger_ok then
      ar[start_index].zaehler:=jaeger_variation
    else
      ar[start_index].zaehler:=beute_variation;
    ar[start_index].x:=x;
    ar[start_index].y:=y;
    ar[start_index].gefressen:=0;

    //neues leben auch in dichte-array
    dichte_ar_setzen(x,y,jaeger_ok,false);

    result:=true;
  finally
    //aktives lebenwesen bekommt immer volle lebenskraft
    if jaeger_ok then ar[inx].zaehler:=jaeger_variation
                 else ar[inx].zaehler:=beute_variation;
    ar[inx].gefressen:=0;
  end;
end;

//-------------------------------------------------------
//alle aktiven jaeger bzw. beute werden gezaehlt und
//gemaess ihrer koordinaten in puffer-bitmap eingezeichnet
//-------------------------------------------------------
function thauptf.leben_zaehlen_malen(
  var ar:array of tleben; //jaeger- oder beute-array
  jaeger_ok:boolean       //werden jaeger betrcahtet?
):smallint;
const
  _farbe_max=180;
var
  sz,r,xx,yy,schritte_max:smallint;
  farbe_delta:double;
  rot_aufheller,farb_anteil:byte;
  farbe:tcolor;
begin
  result:=0;
  sz:=groesse_se.value;

  //maximal moegliche lebens-schritte
  if jaeger_ok then
    schritte_max:=
      jaeger_lebensdauer_se.maxvalue+
      jaeger_variation_se.maxvalue
  else
    schritte_max:=
      beute_teildauer_se.maxvalue+
      beute_variation_se.maxvalue;

  //farbaenderung je lebensschritt
  farbe_delta:=(_farbe_max/schritte_max);
  rot_aufheller:=(255-_farbe_max);

  //durchlaufe jaeger-/beute-array
  for r:=0 to _leben_max-1 do begin
    //ignoriere inaktive lebewesen
    if ar[r].zaehler=_leben_unbenutzt then exit;
    if ar[r].zaehler=_leben_frei then continue;

    //aktiven jaeger/beuite gefunden

    //reduziere lebens- bzw. teildauer um ein jahr
    ar[r].zaehler:=ar[r].zaehler-1;

    //jaeger/beute immer noch im rennen?
    if ar[r].zaehler=_leben_frei then continue;

    //treffer erhoehen
    result:=result+1;

    //lebewesen in dichte-array eintragen
    xx:=ar[r].x div sz;
    yy:=ar[r].y div sz;
    if jaeger_ok then dichte_ar[xx,yy]:=_dichte_jaeger
                 else dichte_ar[xx,yy]:=_dichte_beute;

    //rot/gruen/blau anhand von 'lebenskraft' berechnen
    farb_anteil:=trunc(ar[r].zaehler*farbe_delta);

    //und jaeger/beute in puffer-bitmap eintragen
    if jaeger_ok then begin
      //je kleiner lebensdauer, desto dunkler
      farbe:=rgb(
        farb_anteil+rot_aufheller,
        farb_anteil,
        farb_anteil
      );
      bmp.Canvas.brush.color:=farbe;
      ellipse(
        bmp.canvas.handle,
        ar[r].x,   ar[r].y,
        ar[r].x+sz,ar[r].y+sz
      );
    end
    else begin
      //je laenger teildauer, desto dunkler
      farb_anteil:=255-farb_anteil;
      farbe:=rgb(farb_anteil,255,farb_anteil);
      bmp.Canvas.brush.color:=farbe;
      rectangle(
        bmp.canvas.handle,
        ar[r].x,   ar[r].y,
        ar[r].x+sz,ar[r].y+sz
      );
    end;
  end;
end;

//-------------------------------------------------------
//ist jaeger auf koordinate x/y vorhanden?
//-------------------------------------------------------
function thauptf.jaeger_vorhanden(x,y:smallint;var inx:smallint):boolean;
begin
  result:=leben_vorhanden(jaeger_ar,x,y,inx,true);
end;

//-------------------------------------------------------
//ist beute auf koordinate x/y vorhanden?
//-------------------------------------------------------
function thauptf.beute_vorhanden(x,y:smallint;var inx:smallint):boolean;
begin
  result:=leben_vorhanden(beute_ar,x,y,inx,false);
end;

//-------------------------------------------------------
//berechne dichte um ein lebenwesen
//bei jaegern gelten nur jaeger, bei beute nur beute
//liefert aktuelle dichte und maximal moegliche dichte zurueck
//maximal moegliche dichte kann variieren, wenn sich leben
//an raendern oder eckpunkten befindet
//
// Legende: j=jger, b=beute
//
//  Situation #1       Situation #2      Situation #3
//
//  |jjj               |j_j              |_j_
//  |jJj => dichte=8   |jJ_ => dichte=5  |J__  => dichte=3
//  |jjj    max=8      |jj_    max=8     |jj_    max=5
//
//-------------------------------------------------------
function thauptf.leben_dichte(
  var ar:array of TLeben;  //jaeger- oder leben-array
  inx:smallint;            //index des aktiven leben
  jaeger_ok:boolean;       //jaeger betrachten?
  var dichte_max:smallint  //maximal moegeliche dichte
):smallint;
var
  ch:char;

  //prufe im dichte-array auf jaeger/beute
  function f(x,y:smallint):byte;
  begin
    result:=0;

    //ueber rand oder eckpunkt heraus?
    if (x<0)or(x>raster_breite_max) then exit;
    if (y<0)or(y>raster_hoehe_max)then exit;

    //artgenossen gefunden?
    if dichte_ar[x,y]=ch then result:=1;
    dichte_max:=dichte_max+1;
  end;

var
  x,y:smallint;
begin
  if jaeger_ok then ch:=_dichte_jaeger
               else ch:=_dichte_beute;

  //pixel-koordinaten in array-idzes umrechnen
  x:=ar[inx].x div groesse_se.Value;
  y:=ar[inx].y div groesse_se.Value;

  //zaehle artgenossen um index-leben herum
  result:=
    f(x-1,y-1)+f(x,y-1)+f(x+1,y-1)+
    f(x-1,y  )+        +f(x+1,y  )+
    f(x-1,y+1)+f(x,y+1)+f(x+1,y+1);
end;

//-------------------------------------------------------
//existiert jaeger oder beute auf koordinate?
//-------------------------------------------------------
function thauptf.leben_vorhanden(
  var ar:array of TLeben;
  x,y:smallint;
  var inx:smallint;
  jaeger_ok:boolean
):boolean;
var
  r,xx,yy:smallint;
begin
  //pixel-koordinaten in dichte-indizes umwandeln
  xx:=x div groesse_se.Value;
  yy:=y div groesse_se.Value;

  //jaeger bzw. beute gefunden?
  if jaeger_ok then result:=(dichte_ar[xx,yy]=_dichte_jaeger)
               else result:=(dichte_ar[xx,yy]=_dichte_beute);

  //genauer ort egal?
  if inx=-1 then exit;

  //kein leben gefunden?
  if not result then exit;

  //bestimme index des gefundenen lebens
  result:=false;
  for r:=0 to _leben_max-1 do begin
    //ignoriere inaktive leben
    if ar[r].zaehler=_leben_unbenutzt then exit;
    if ar[r].zaehler=_leben_frei then continue;

    //leben mit gefunden leben aus dichte-array identisch?
    if (ar[r].x<>x)or(ar[r].y<>y)then continue;

    //yep, liefere index zurueck
    inx:=r;
    result:=true;
    break;
  end;
end;

//-------------------------------------------------------
//bewege ein jaeger oder eine beute in zufaelliger weise,
//so dass sich jaeger moeglichst auf naheste beute zubewegt
//bzw. beute vom nahesten jaeger fortbewegt.
//-------------------------------------------------------
function thauptf.leben_bewegung(
  var ar:array of TLeben;
  inx,x_gefunden,y_gefunden:smallint;
  jaeger_ok:boolean
):smallint;
var
  x,y,delta_x,delta_y,index_gefunden:smallint;
begin
  result:=_leben_frei;

  //x: bewege dich auf beute zu bzw. von jaeger weg
  x:=ar[inx].x;
  delta_x:=0;
  if      x<x_gefunden then delta_x:=pos_delta
  else if x>x_gefunden then delta_x:=-pos_delta;
  if not jaeger_ok then delta_x:=-delta_x;

  //y: bewege dich auf beute zu bzw. von jaeger weg
  y:=ar[inx].y;
  delta_y:=0;
  if      y<y_gefunden then delta_y:=pos_delta
  else if y>y_gefunden then delta_y:=-pos_delta;
  if not jaeger_ok then delta_y:=-delta_y;

  //ortsaenderung gegeben?
  if(delta_x=0)and(delta_y=0)then exit;

  //berechne neue pixel-koordinaten
  if delta_x<>0 then x:=pos_raster_x(x+delta_x);
  if delta_y<>0 then y:=pos_raster_y(y+delta_y);

  //neue position frei von leben?
  index_gefunden:=_leben_frei;
  if leben_vorhanden(ar,x,y,index_gefunden,jaeger_ok) then exit;

  //ja, dann aendere position

  //alte position im dichte-array freigeben
  dichte_ar_setzen(ar[inx].x,ar[inx].y,jaeger_ok,true);

  if jaeger_ok then begin
    //hockt auf neuer position des jaeger eine beute?
    //wenn ja, rette beute-index in dum
    index_gefunden:=0;
    if beute_vorhanden(x,y,index_gefunden) then
      result:=index_gefunden;
  end;

  //neue position eintragen
  ar[inx].x:=x;
  ar[inx].y:=y;
  dichte_ar_setzen(x,y,jaeger_ok,false);
end;

//-------------------------------------------------------
//initiierung der evolutions-umgebung
//-------------------------------------------------------
procedure thauptf.evolution_init;
var
  r:smallint;
begin
  mitte_pResize(nil);

  //plausibiliaet fuer startwerte
  if jaeger_start_se.value>jaeger_max_se.value then
    jaeger_start_se.value:=jaeger_max_se.value;
  jaeger_lebensdauer_se.value:=jaeger_lebensdauer_start_se.value;
  if beute_start_se.value>beute_max_se.value then
    beute_start_se.value:=beute_max_se.value;
  beute_teildauer_se.value:=beute_teildauer_start_se.value;

  //jaeger- und beute-array loeschen
  for r:=0 to _leben_max-1 do begin
    Jaeger_ar[r].zaehler:=_leben_unbenutzt;
    Beute_ar[r].zaehler:=_leben_unbenutzt;
  end;

  //neues leben schaffen
  leben_neu(jaeger_ar,true);
  leben_neu(beute_ar,false);

{
jaeger_ar[0].x:=pos_raster_x(  0);jaeger_ar[0].y:=pos_raster_y(  0);jaeger_ar[0].zaehler:=10;
jaeger_ar[1].x:=pos_raster_x(500);jaeger_ar[1].y:=pos_raster_y(500);jaeger_ar[1].zaehler:=20;

beute_ar[0].x:=pos_raster_x(100);beute_ar[0].y:=pos_raster_y(200);beute_ar[0].zaehler:=1;
beute_ar[1].x:=pos_raster_x(200);beute_ar[1].y:=pos_raster_y(200);beute_ar[1].zaehler:=3;
beute_ar[2].x:=pos_raster_x(300);beute_ar[2].y:=pos_raster_y(200);beute_ar[2].zaehler:=5;
beute_ar[3].x:=pos_raster_x(100);beute_ar[3].y:=pos_raster_y(300);beute_ar[3].zaehler:=6;
}
end;

//-------------------------------------------------------
//bewege die population der jaeger
//-------------------------------------------------------
procedure thauptf.jaeger_bewegen(
  var dichte:smallint;      //reale dichte um jaeger herum
  var dichte_max:smallint;  //maximal moegeliche dichte
  var duplikat_ok:boolean   //mindestens eine reproduktion?
);
var
  r,inx,start_index:smallint;
  x_gefunden,y_gefunden:smallint;
begin
  start_index:=0;
  duplikat_ok:=false;
  dichte:=0;dichte_max:=0;

  //durchlaufe jaeger-array
  for r:=0 to jaeger_max_se.value-1 do begin
    //ignoriere inaktive jaeger
    if jaeger_ar[r].zaehler=_leben_unbenutzt then exit;
    if jaeger_ar[r].zaehler=_leben_frei then continue;

    //summiere reale und maximal moegliche dichte auf
    dichte:=
      dichte+
      leben_dichte(jaeger_ar,r,true,dichte_max);

    //suche naheste beute zum aktiven jaeger
    if not leben_finde(beute_ar,r,x_gefunden,y_gefunden,false)then
      continue;

    //beute gefunden: bewege jaeger dorthin
    inx:=leben_bewegung(jaeger_ar,r,x_gefunden,y_gefunden,true);

    //hat jaeger beute erwischt?
    if inx=_leben_frei then continue;

    //jep: lass beute sterben
    beute_ar[inx].zaehler:=_leben_frei;
    dichte_ar_setzen(beute_ar[inx].x,beute_ar[inx].y,false,true);

    //erhoehe beutetreffer des jaegers
    jaeger_ar[r].gefressen:=jaeger_ar[r].gefressen+1;

    //genug beute gerissen fuer reproduktion?
    if jaeger_ar[r].gefressen<_beute_fuer_duplikat then
      continue;

    //ja, jaeger dupliziert sich (falls moeglich)
    if leben_duplikat(jaeger_ar,r,true,start_index) then
      duplikat_ok:=true;
  end;
end;


//-------------------------------------------------------
//bewege die population der beute
//-------------------------------------------------------
procedure thauptf.beute_bewegen(
  var dichte:smallint;      //reale dichte um beute herum
  var dichte_max:smallint;  //maximal moegeliche dichte
  var duplikat_ok:boolean   //mindestens eine reproduktion?
);
var
  r,start_index:smallint;
  x_gefunden,y_gefunden:smallint;
  dichte_einzeln,dichte_einzeln_max:smallint;
begin
  start_index:=0;
  duplikat_ok:=false;
  dichte:=0;dichte_max:=0;

  //durchlaufe beute-array
  for r:=0 to beute_max_se.value-1 do begin
    //ignoriere inaktive beute
    if beute_ar[r].zaehler=_leben_unbenutzt then exit;
    if beute_ar[r].zaehler=_leben_frei then continue;

    //bestimme dichte um aktive beute
    dichte_einzeln_max:=0;
    dichte_einzeln:=leben_dichte(
      beute_ar,r,false,dichte_einzeln_max
    );

    //aufsummierte dichte ueber alle beute-tiere
    dichte:=dichte+dichte_einzeln;
    dichte_max:=dichte_max+dichte_einzeln_max;

    //bewegung ueberhaupt moeglich?
    if dichte_einzeln=dichte_einzeln_max then continue;

    //jep: also suche nach nahestem jaeger
    if leben_finde(jaeger_ar,r,x_gefunden,y_gefunden,true)then begin
      //jaeger gefunden: beute entfernt sich von ihm
      leben_bewegung(beute_ar,r,x_gefunden,y_gefunden,false);
    end;

    //lebt beute lang genug fuer duplizierung?
    if beute_ar[r].zaehler>0 then continue;

    //ja: beute reproduziert sich (falls moeglich)
    if leben_duplikat(beute_ar,r,false,start_index) then
      duplikat_ok:=true;
  end;
end;

//-------------------------------------------------------
//finde nahestes leben zu index-tier
//
//   0 1 2 3 4
// 0 _ _ _ _ _     abstand jaeger zur beute =
// 1 _ j _ _ _  => abs(3-1)+abs(2-1) =
// 2 _ _ _ b _     2+1 =
// 3 _ _ _ _ _     3
//
//-------------------------------------------------------
function thauptf.leben_finde(
  var ar:array of tleben;  //jaeger- oder beute-array
  inx:smallint;            //index aktives leben
  var x,y:smallint;        //treffer-koordinaten
  jaeger_ok:boolean        //wird jaeger betrcahtet?
):boolean;
var
  r,abstand,abstand_min:smallint;
begin
  result:=false;
  abstand_min:=-1;
  x:=-1;y:=-1;

  //durchlaufe leben-array
  for r:=0 to _leben_max-1 do begin
    //ignoriere inaktives leben
    if ar[r].zaehler=_leben_unbenutzt then exit;
    if ar[r].zaehler=_leben_frei then continue;

    if jaeger_ok then
      //abstand aktiver jaeger zu index-beute
      abstand:=
        abs(beute_ar[inx].x-jaeger_ar[r].x)+
        abs(beute_ar[inx].y-jaeger_ar[r].y)
    else
      //abstand aktive beute zu index-jaeger
      abstand:=
        abs(jaeger_ar[inx].x-beute_ar[r].x)+
        abs(jaeger_ar[inx].y-beute_ar[r].y);

    //neues minimum gefunden?
    if(abstand_min=-1)or(abstand<abstand_min) then begin
      //je: position und index merken
      x:=ar[r].x;
      y:=ar[r].y;

      //neuen minmal-abstand merken
      abstand_min:=abstand;
      result:=true;

      //direkter nachbar? naeher gehts nicht
      if abstand_min<=groesse_se.Value then exit;
    end;
  end;
end;

//-------------------------------------------------------
//neuer lebensdauer-wert eines jaeger
//variiert um zufallswert nach oben und unten
//-------------------------------------------------------
function thauptf.jaeger_variation:smallint;
begin
  result:=jaeger_variation_se.value;
  result:=
    jaeger_lebensdauer_se.value+
    random(result)-random(result);
  if result<_jaeger_lebensdauer_min then
    result:=_jaeger_lebensdauer_min;
end;

//-------------------------------------------------------
//neuer teildauer-wert einer beute
//variiert um zufallswert nach oben und unten
//-------------------------------------------------------
function thauptf.beute_variation:smallint;
begin
  result:=beute_variation_se.value;
  result:=
    beute_teildauer_se.value+
    random(result)-random(result);
  if result<_beute_teildauer_min then
    result:=_beute_teildauer_min;
end;

//-------------------------------------------------------
//aktiviert/deaktiviert knoepfe und spinedits
//abhaengig, ob evolution laeuft oder nicht
//-------------------------------------------------------
procedure thauptf.knoepfe_setzen(evolution_ok:boolean);
begin
  jaeger_start_se.enabled:=not evolution_ok;
  jaeger_zaehler_e.enabled:=evolution_ok;
  jaeger_lebensdauer_start_se.enabled:=not evolution_ok;
  jaeger_lebensdauer_se.enabled:=evolution_ok;

  beute_start_se.enabled:=not evolution_ok;
  beute_zaehler_e.enabled:=evolution_ok;
  beute_teildauer_start_se.Enabled:=not evolution_ok;
  beute_teildauer_se.enabled:=evolution_ok;

  if evolution_ok then begin
    startb.caption:='STOPP';
    pauseb.caption:='Pause';
  end
  else begin
    startb.caption:='Start';
    pauseb.caption:='Pause';
  end;
  pauseb.enabled:=evolution_ok;
  groesse_se.enabled:=not evolution_ok;
end;


//-------------------------------------------------------
//skaliert x-koordinaten-werte derart, dass sie sich
//auf block-raster-spalten bewegen.
//-------------------------------------------------------
function thauptf.pos_raster_x(x:smallint):smallint;
begin
  x:=x div groesse_se.Value;

  //verbotene koordinaten abfangen
  if x<0 then x:=0;
  if x>raster_breite_max then x:=raster_breite_max;

  //um randwert korrigieren
  result:=raster_rand_breite+(x*groesse_se.Value);
end;

//-------------------------------------------------------
//skaliert y-koordinaten-werte derart, dass sie sich
//auf block-raster-zeilen bewegen.
//-------------------------------------------------------
function thauptf.pos_raster_y(y:smallint):smallint;
begin
  y:=y div groesse_se.Value;

  //verbotene koordinaten abfangen
  if y<0 then y:=0;
  if y>raster_hoehe_max then y:=raster_hoehe_max;

  //um randwert korrigieren
  result:=raster_rand_hoehe+(y*groesse_se.Value);
end;

//--------------------------------------------------------
//pausiere evolution um ms millisekunden
//--------------------------------------------------------
procedure Thauptf.pause(ms:smallint);
var
  r:smallint;
begin
  for r:=0 to (ms div 10) do begin
    application.processmessages;
    sleep(10);
  end;
end;

//-------------------------------------------------------
//gib aktuelle evolutions-runde aus
//-------------------------------------------------------
procedure thauptf.evolution_ausgabe;
var
  x,y,zaehler:smallint;
begin
  //puffer-bitmap loeschen
  bmp.canvas.brush.color:=clblack;
  rectangle(bmp.Canvas.Handle,0,0,bmp.width,bmp.Height);

  //dichte-array leeren
  for y:=0 to raster_hoehe_max do begin
    for x:=0 to raster_breite_max do begin
      dichte_ar[x,y]:=_dichte_frei;
    end;
  end;

  //zaehle jaeger und zeichne sie auf puffer-bitmap
  zaehler:=leben_zaehlen_malen(jaeger_ar,true);
  jaeger_zaehler_e.Text:=inttostr(zaehler);
  jaeger_zaehler:=zaehler;

  //kein jaeger mehr gefunden? dann evolution fertig
  if zaehler=0 then startb.caption:='Start';

  //zaehle beute und zeichne sie auf puffer-bitmap
  zaehler:=leben_zaehlen_malen(beute_ar,false);
  beute_zaehler_e.Text:=inttostr(zaehler);
  beute_zaehler:=zaehler;

  //keine beute mehr gefunden? dann evolution fertig
  if zaehler=0 then startb.caption:='Start';

  //puffer-bitmap auf paintbox kopieren
  bitblt(
    pb.canvas.Handle,0,0,pb.width,pb.height,
    bmp.Canvas.Handle,0,0,
    srccopy
  );
end;

//-------------------------------------------------------
//evolution abbremsen? pausieren? oder abbrechen?
//-------------------------------------------------------
function thauptf.bremsen_pause_abbruch:boolean;
begin
  //bremsen?
  if bremse_se.value=0 then begin
    application.processmessages;
  end
  else pause(bremse_se.value);

  //pause?
  if pauseb.caption='Weiter' then begin
    startb.enabled:=false;
    while pauseb.caption='Weiter' do begin
      application.processmessages;
      sleep(10);
    end;
    startb.enabled:=true;
  end;

  //ende oder abbruch?
  result:=(startb.caption<>'STOPP');
end;

//-------------------------------------------------------
//evolution-haupt-schleife
//-------------------------------------------------------
procedure thauptf.evolution;
var
  dichte,dichte_max:smallint;
  runden_zaehler:smallint;
  duplikat_ok:boolean;
begin
  knoepfe_setzen(true);

  //evolutions-parameter setzen
  evolution_init;

  //ewig-schleife beginnen
  runden_zaehler:=0;
  repeat
    //evolutions-runde anzeigen
    evolution_ausgabe;

    //abbruchs-kriterien erfuellt?
    if bremsen_pause_abbruch then break;

    //jaeger auf beute zubewegen
    jaeger_bewegen(dichte,dichte_max,duplikat_ok);

    //lern-parameter adaptieren, abhaengig von
    //fress-erfolg und dichte der jaeger
    jaeger_lernen(dichte,dichte_max,duplikat_ok);

    //beute vor jeaegern fliehen lassen
    beute_bewegen(dichte,dichte_max,duplikat_ok);

    //lern-parameter adaptieren, abhaengig von
    //teilung-erfolg und dichte der beute
    beute_lernen(dichte,dichte_max,duplikat_ok);

    //rundenzaehler erhoehen und ausgeben
    inc(runden_zaehler);
    runden_zaehler_e.Text:=inttostr(runden_zaehler);
  until false;

  knoepfe_setzen(false);
end;

end.

